# Bumble MVP 🐝

Bumble is a simple command line ruby gem to assist Android development with generating entities in the Model-View-Present Pattern.

## Installation

Install globally as Ruby Gem.

```
$ gem install bumblemvp
```

## Usage

Say you want to create an entity like a Task for your To-do app.
#### Make sure your in your java files folder of your project in command line
(I haven't figured out a clever way create files from the app/ root. Pull requests welcome 😀)

```
bumble generate User
```

This generates a new package for the Task entity, as well as sets up some basic skeleton interfaces for the View and Presenters objects
```
.
├── User
│   └── UserContract.java
└── data
    ├── User.java
    └── source
        ├── UserDataSource.java
        ├── UserRepository.java
        ├── local
        └── remote
```

Bumble was developed using [Google's Samples](https://github.com/googlesamples/android-architecture/tree/todo-mvp/)

## Development

After checking out the repo, run `bin/setup` to install dependencies. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/robertsimoes/bumble. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [Contributor Covenant](http://contributor-covenant.org) code of conduct.


## License

The gem is available as open source under the terms of the [MIT License](http://opensource.org/licenses/MIT).
